//+------------------------------------------------------------------+
//|                                                      Paradox.mq4 |
//|                                       Copyright  2008 bobfourie |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008 bobfourie"
#property link      ""

extern string s0 = "Game A/B Choice: 0-Random 1-Sequence 2-Mod";
extern int iChoosingMethod = 0;
extern double dM = 3;
extern int iMagic = 200;
extern int iStoploss = 50;
extern int iTakeProfit = 50;
extern int iStepStart = 20;
extern int iStepSize = 50;
extern int iTrailingStop = 40;
extern string s1 = "Game A";
extern int iMaxTimeBetweenTrades = 21600;
extern string s2 = "Game B1";
extern int iTimeFrameB1 = 60;
extern int iMA_Period = 100;
extern string s3 = "Game B2";
extern int iTimeFrameB2 = 60;
extern string s4 = "Money Management";
extern double dLots = 0.01;
extern bool UseMoneyMgmt = false;
extern double RiskPercent = 2;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   GlobalVariableSet("sMethod"+Symbol(),-1);
   MathSrand(TimeLocal());
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   GlobalVariableDel("sMethod"+Symbol()) ;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
//OpenOrder(Symbol(),OP_BUY,dLots,333,"stepper checker",0,0);
// Stepper(string sOrderSymbol,int iMagic, int iType,string sOrderComment, int iOrderTicket,int StepStart,int StepSize)
//Stepper(Symbol(),333,OP_BUY ,-1, -1, 10, 10);
//Trailing(Symbol(),333, -1,-1,-1,iTrailingStop);
//Trailing(Symbol(),201, -1,-1,-1,10);
//return;
//Stepper(Symbol(),333,OP_SELL ,-1, -1, 10, 10);
//return;
//EUR/USD, GBP/USD, GBP/JPY, USD/CHF and USD/JPY martingale (3 times max)
//Picks between Game A and Game B
if(GlobalVariableGet("sMethod"+Symbol()) == -1 && !SelectOrder(Symbol() ,iMagic,-1, -1, -1) && !SelectOrder(Symbol() ,iMagic+1,-1, -1, -1) && !SelectOrder(Symbol() ,iMagic+2,-1, -1, -1))
{
 GamePicker(iChoosingMethod, dM);
 //GlobalVariableSet("sMethod"+Symbol(),1);
}


 if(GlobalVariableGet("sMethod"+Symbol()) == 0)SignalA(Symbol(), iMagic ,dLots ,iStoploss, iTakeProfit);
//if Game B are pick, must pick between Game B1 and Game B2 
 if(GlobalVariableGet("sMethod"+Symbol()) == 1)
  {
   SelectOrder(Symbol() ,iMagic+1,-1,-1, -1,MODE_HISTORY);
   if(OrderProfit()<0)SignalB2(Symbol(), iMagic ,dLots, iStoploss, iTakeProfit, iTimeFrameB2);
   else SignalB1(Symbol(), iMagic ,dLots, iStoploss,iTakeProfit,iTimeFrameB1 ,iMA_Period);
  }
//Print(GlobalVariableGet("sMethod"+Symbol()));
}

void GamePicker(int iPickType,double dM)
{
  int iSeq[5] = {0,1,1,0,1};
  static int iSequence = -1;
  if (iSequence == 4)iSequence = -1;
 
  switch(iPickType)
  {
   case 0:  if(RndGen()>0.5)GlobalVariableSet("sMethod"+Symbol(),0);
            else GlobalVariableSet("sMethod"+Symbol(),1);
            //Will randomly choose between Game A and B
 
   case 1:  iSequence++;
            GlobalVariableSet("sMethod"+Symbol(),iSeq[iSequence]);
            //Will insequence choose between Game A and B
   
   case 2:  if(MathMod(StrToDouble(DoubleToStr(AccountBalance(),0)),dM) == 0)
            GlobalVariableSet("sMethod"+Symbol(),0);
            else GlobalVariableSet("sMethod"+Symbol(),1);
            //If balance is dividable by M, Choose Game A, else B
 }
 
 if(GlobalVariableGet("sMethod"+Symbol()) == -1 && !SelectOrder(Symbol() ,iMagic,-1, -1, -1) && !SelectOrder(Symbol() ,iMagic+1,-1, -1, -1) && !SelectOrder(Symbol() ,iMagic+2,-1, -1, -1))
  {
    if(RndGen()>0.5)GlobalVariableSet("sMethod"+Symbol(),0);
    else GlobalVariableSet("sMethod"+Symbol(),1);
  }
 
}

void SignalB2(string sSymbol, int iMagic ,double dLots,int iStoploss,int iTakeProfit,int iTimeframe)
{
string sMethod = "";
if(iChoosingMethod == 0)sMethod = "Random";
else sMethod = "Sequence";
   Comment( "Method of Choosing Games: "+sMethod+"\n"+
            "Game B2"+"\n"+
            "Retracement");

 double dDem0 = iDeMarker( Symbol(), iTimeframe, 14,0); 
 double dDem5 = iDeMarker( Symbol(), iTimeframe, 14,5); 
 double dStoch0 = iStochastic( Symbol(), iTimeframe, 10 ,6, 6, MODE_SMA, 0 , MODE_MAIN,0); 
 double dStoch5 = iStochastic( Symbol(), iTimeframe, 10 ,6, 6, MODE_SMA, 0 , MODE_MAIN,5);
 double dCCI0 = iCCI( Symbol(), iTimeframe, 14, PRICE_CLOSE, 0) ;
 double dCCI5 = iCCI( Symbol(), iTimeframe, 14, PRICE_CLOSE, 5) ;

 int iCounter = 0;
 if(dDem5 > 0.5 && dDem0 < 0.5 )iCounter--;
 if(dStoch5 > 50 && dStoch0 < 50 )iCounter--;
 if(dCCI5 > 0 && dCCI0 < 0 )iCounter--;
 
 if(dDem5 < 0.5 && dDem0 > 0.5 )iCounter++;
 if(dStoch5 < 50 && dStoch0 > 50 )iCounter++;
 if(dCCI5 < 0 && dCCI0 > 0 )iCounter++;

 if(iCounter <= -2 && !SelectOrder(sSymbol,iMagic+2,OP_SELL,-1, -1))
 {
   OpenOrder(Symbol(),OP_SELL,dLots,iMagic+2,"B2",iStoploss,iTakeProfit);
   return;
 }
 if(iCounter >= 2 && !SelectOrder(sSymbol,iMagic+2,OP_BUY,-1, -1))
 {
   OpenOrder(Symbol(),OP_BUY,dLots,iMagic+2,"B2",iStoploss,iTakeProfit);
   return;
 }
 
 //Game Signal if orders are all closed
 
 //  if(iCounter >= 2 && SelectOrder(sSymbol,iMagic+2,OP_SELL,-1, -1))
 //      CloseOrder(iMagic+2, OP_SELL);
  
 //  if(iCounter <= -2 && SelectOrder(sSymbol,iMagic+2,OP_BUY,-1, -1))
 //     CloseOrder(iMagic+2, OP_BUY);
   
   //Stepper(Symbol(),iMagic+2, -1,-1, -1, iStepStart, iStepSize);
   //Trailing(Symbol(),iMagic+2, -1,-1,-1,iTrailingStop);
   
   //Clear Game Signal if orders are all closed
   if(!SelectOrder(sSymbol,iMagic+2,-1,-1, -1))
   {
      GlobalVariableSet("sMethod"+Symbol(),-1);
   }


}
void SignalB1(string sSymbol, int iMagic ,double dLots,int iStoploss,int iTakeProfit,int iTimeframe,int iMA_Period)
{
string sMethod = "";
if(iChoosingMethod == 0)sMethod = "Random";
else sMethod = "Sequence";
   Comment( "Method of Choosing Games: "+sMethod+"\n"+
            "Game B1"+"\n"+
            "Trending");
double dMA0 = iMA(sSymbol,iTimeframe,iMA_Period,0,MODE_LWMA ,PRICE_CLOSE,0);
double dMA1 = iMA(sSymbol,iTimeframe,iMA_Period,0,MODE_LWMA,PRICE_CLOSE,1);
double dMacd0 = iMACD(sSymbol, iTimeframe,24, 52, 18, PRICE_CLOSE, MODE_MAIN, 0);
double dMacd1 = iMACD(sSymbol, iTimeframe,24, 52, 18, PRICE_CLOSE, MODE_MAIN, 1);
double dMacdSig0 = iMACD(sSymbol, iTimeframe,24, 52, 18, PRICE_CLOSE, MODE_SIGNAL, 0);
double dMacdSig1 = iMACD(sSymbol, iTimeframe,24, 52, 18, PRICE_CLOSE, MODE_SIGNAL, 1);      

 int iCounter = 0;
 
 if(dMA0<0)
 {
   if(dMA0<dMacdSig0 && dMacd0<dMacd1 )iCounter--;
   if(dMA0>dMacdSig0 && dMacd0>dMacd1)iCounter++;
 }
  if(dMA0>0)
 {
   if(dMA0>dMacdSig0 && dMacd0>dMacd1)iCounter++;
   if(dMA0<dMacdSig0 && dMacd0<dMacd1)iCounter--;   
 }
 
 if(dMA0<dMA1)iCounter--;
 if(dMA0>dMA1)iCounter++;
 
   if (iCounter <= -2 && !SelectOrder(sSymbol,iMagic+1,OP_SELL,-1, -1))
   {
      OpenOrder(Symbol(),OP_SELL,dLots,iMagic+1,"B1",iStoploss,iTakeProfit);
      return;
   }
   if (iCounter >= 2 && !SelectOrder(sSymbol,iMagic+1,OP_BUY,-1, -1))
   {
      OpenOrder(Symbol(),OP_BUY,dLots,iMagic+1,"B1",iStoploss,iTakeProfit);
      return;
   }
   
   //if(iCounter == -1 || iCounter == 1 || iCounter == 0)
  // {
  //    CloseOrder(iMagic+1, OP_BUY);
  //    CloseOrder(iMagic+1, OP_SELL);
  // }

   //Stepper(Symbol(),iMagic+1, -1,-1, -1, iStepStart, iStepSize);
   //Trailing(Symbol(),iMagic+1, -1,-1,-1,iTrailingStop);
   
   //Clear Game Signal if orders are all closed
   if(!SelectOrder(sSymbol,iMagic+1,-1,-1, -1))
   {
      GlobalVariableSet("sMethod"+Symbol(),-1);
   }

}

void SignalA(string sSymbol, int iMagic, double dLots,int iStoploss,int iTakeProfit)
{
//iStoploss = 100;
//iTakeProfit = 100;
static int iBuyNextTradeTime = 0;
static int iSellNextTradeTime = 0;

//For first time run, set new random start times
if(iSellNextTradeTime == 0) iSellNextTradeTime = TimeLocal() + RndGen() * iMaxTimeBetweenTrades;
if(iBuyNextTradeTime == 0) iBuyNextTradeTime = TimeLocal() + RndGen() * iMaxTimeBetweenTrades;
//end first time run

   if(!SelectOrder(sSymbol ,iMagic,OP_SELL, -1, -1) && iSellNextTradeTime < TimeLocal() && !SelectOrder(Symbol() ,iMagic,-1, -1, -1) )
   {
      OpenOrder(Symbol(),OP_SELL,dLots,iMagic+0,"A",iStoploss,iTakeProfit);
      iSellNextTradeTime = 0;
      GlobalVariableSet("sMethod"+Symbol(),-1);
   }

   if(!SelectOrder(Symbol() ,iMagic,OP_BUY, -1, -1) && iBuyNextTradeTime < TimeLocal()  && !SelectOrder(Symbol() ,iMagic,-1, -1, -1) )
   {
      OpenOrder(Symbol(),OP_BUY,dLots,iMagic+0,"A",iStoploss,iTakeProfit);
      iBuyNextTradeTime = 0;
      GlobalVariableSet("sMethod"+Symbol(),-1);
   }

//---------Comments----------
 string sNextBuyTime = CheckStringTime(TimeToStr(iBuyNextTradeTime-TimeLocal(),TIME_MINUTES|TIME_SECONDS));
 string sNextSellTime = CheckStringTime(TimeToStr(iSellNextTradeTime-TimeLocal(),TIME_MINUTES|TIME_SECONDS ));
 string sNextTradeTime = "";
 if((iBuyNextTradeTime-TimeLocal()) > (iSellNextTradeTime-TimeLocal()))
 sNextTradeTime = sNextSellTime;
 else sNextTradeTime = sNextBuyTime;

 string sMethod = "";
 if(iChoosingMethod == 0)sMethod = "Random";
 else sMethod = "Sequence";
   Comment( "Method of Choosing Games: "+sMethod+"\n"+
            "Game A"+"\n"+
            "Random"+"\n"+
            "Next Trade Time: "+sNextTradeTime+"\n"+
            "");           
//---------Comments End ------- 
}

//Random Generator
double RndGen()
{
double dRand = MathRand();
double dSymbolNum = StrToDouble(MagicGS(StringSubstr(Symbol(), 0, 3))+""+MagicGS(StringSubstr(Symbol(), 3, 3)));
return(StrToDouble(StringSubstr(DoubleToStr(dRand+dSymbolNum,0), StringLen(DoubleToStr(dRand+dSymbolNum,0))-2 )) / 99);
}

int MagicGS(string s)
{
if(s == "EUR")return(1);
if(s == "USD")return(2);
if(s == "GBP")return(3);
if(s == "JPY")return(4);
if(s == "CHF")return(5);
return(0);
}

string CheckStringTime(string sTime)
{
if(sTime == "invalid time")return("-");
else return(sTime);
}

//================ Open Orders =========================================================================================  
//

void OpenOrder(string sSymbol,int iType, double dLots,int iMagic,string sComment,double dStoploss,double dTakeProfit)
{ 
 dLots = GetLots(Symbol(), dLots, UseMoneyMgmt, RiskPercent, true);
 
 if(iType == OP_BUY)
  {
    if(dStoploss>0) dStoploss = MarketInfo(sSymbol,MODE_ASK)-dStoploss*MarketInfo(sSymbol,MODE_POINT);
   if(dTakeProfit>0)  dTakeProfit = MarketInfo(sSymbol,MODE_ASK)+dTakeProfit*MarketInfo(sSymbol,MODE_POINT);
  }
  if(iType == OP_SELL)
 {
   if(dStoploss>0)   dStoploss = MarketInfo(sSymbol,MODE_BID)+dStoploss*MarketInfo(sSymbol,MODE_POINT);
   if(dTakeProfit>0) dTakeProfit = MarketInfo(sSymbol,MODE_BID)-dTakeProfit*MarketInfo(sSymbol,MODE_POINT);
 }
 RefreshRates();
      if(iType == OP_BUY) OrderSend(sSymbol,OP_BUY,dLots,Ask,3,dStoploss,dTakeProfit,sComment,iMagic,0,Blue);
      if(iType == OP_SELL) OrderSend(sSymbol,OP_SELL,dLots,Bid,3,dStoploss,dTakeProfit,sComment,iMagic,0,Blue);
}
//

//=============== Close Orders =========================================================================
//

void CloseOrder(int iMagic, int iType)
{
   RefreshRates();
   if(SelectOrder(Symbol() ,iMagic,iType, -1, -1))
   OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),3,Blue); 
}
//

//=============== Select Orders =========================================================================
//
bool SelectOrder(string sOrderSymbol ,int iMagic, int iType, string sOrderComment, int iOrderTicket, int iPool = MODE_TRADES)
{
   sOrderSymbol = MiniCheck(sOrderSymbol);
   int cnt,total;
    if(iPool == MODE_TRADES)total = OrdersTotal();
    else total = OrdersHistoryTotal();
    
     for(cnt=total-1;cnt>=0;cnt--)
      {
        OrderSelect(cnt, SELECT_BY_POS, iPool);
        if ((OrderSymbol() == sOrderSymbol || sOrderSymbol == "-1") && (OrderMagicNumber()==iMagic || iMagic == -1)  && (OrderType()==iType || iType == -1) && (OrderComment() == sOrderComment || sOrderComment =="-1")  && (OrderTicket() == iOrderTicket || iOrderTicket == -1))
        return(true);
      }
     return(false);
} 

double GetLots(string sSymbol, double Lots, bool UseMoneyMgmt, double RiskPercent, bool BrokerPermitsFractionalLots)
{
// variables used for money management
double         MM_MinLotSize=0;
double         MM_MaxLotSize=0;
double         MM_LotStep=0;
double         MM_Decimals=0;
int            MM_AcctLeverage=0;
int            MM_CurrencyLotSize=0;
 
 sSymbol = MiniCheck(sSymbol);
 double OrderLotSize;
 
//----- Money Management & Lot Sizing Stuff.

  MM_AcctLeverage = AccountLeverage();
  MM_MinLotSize = MarketInfo(sSymbol,MODE_MINLOT);
  MM_MaxLotSize = MarketInfo(sSymbol,MODE_MAXLOT);
  MM_LotStep = MarketInfo(sSymbol,MODE_LOTSTEP);
  MM_CurrencyLotSize = MarketInfo(sSymbol,MODE_LOTSIZE);

  if(MM_LotStep == 0.01) {MM_Decimals = 2;}
  if(MM_LotStep == 0.1) {MM_Decimals = 1;}

  if (UseMoneyMgmt == true)
   {
    OrderLotSize = AccountEquity() * (RiskPercent * 0.01) / (MM_CurrencyLotSize / MM_AcctLeverage);
    if(BrokerPermitsFractionalLots == true)
      OrderLotSize = StrToDouble(DoubleToStr(OrderLotSize,MM_Decimals));
    else
      OrderLotSize = MathRound(OrderLotSize);
   }
   else
   {
    OrderLotSize = Lots;
   }

  if (OrderLotSize < MM_MinLotSize) {OrderLotSize = MM_MinLotSize;}
  if (OrderLotSize > MM_MaxLotSize) {OrderLotSize = MM_MaxLotSize;}

  return(OrderLotSize);
  
}

//Check if it is an mini acc or not and adjust symbol if needed
string MiniCheck(string sSymbol)
{
  if(StringFind(sSymbol, "m", 0) >= 0 && (StringFind(Symbol(), "m", 0) >= 0) )return(sSymbol);
  if(StringFind(sSymbol, "m", 0) >= 0 && !(StringFind(Symbol(), "m", 0) >= 0) )return(StringSubstr(sSymbol, 0, 6));
  if( !(StringFind(sSymbol, "m", 0) >= 0) && (StringFind(Symbol(), "m", 0) >= 0) )return(sSymbol+"m");
  return (sSymbol);
}

